package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.PPModel;
import com.sa.ibiz.demo.demo.service.PPModelService;
import com.sa.ibiz.demo.demo.service.dto.PPModelSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/ppmodel")
public class PPModelResource
{
	@Autowired
	private PPModelService service;


	@GetMapping(value = "/{id}")
	public ResponseEntity<PPModel> get(@Validated @PathVariable String id){
		PPModel data=new PPModel();
		data.setPpmodelid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("门户页面模型[get]操作发生错误","PPModel",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<PPModel> checkKey(@Validated @RequestBody PPModel data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("门户页面模型[checkKey]操作发生错误","PPModel",data.getPpmodelid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<PPModel> getDraft(@Validated @RequestBody PPModel data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("门户页面模型[getDraft]操作发生错误","PPModel","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<PPModel> create(@Validated @RequestBody PPModel data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("门户页面模型[create]操作发生错误","PPModel",data.getPpmodelid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<PPModel> update(@Validated @RequestBody PPModel data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("门户页面模型[update]操作发生错误","PPModel",data.getPpmodelid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<PPModel> remove(@Validated @RequestBody PPModel data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("门户页面模型[remove]操作发生错误","PPModel",data.getPpmodelid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<PPModel>> searchDefaultPage(@Validated @RequestBody PPModelSearchFilter filter){
		Page<PPModel> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<PPModel>> listDefault(@Validated @RequestBody PPModelSearchFilter filter){
		List<PPModel> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
